#include <bits/stdc++.h>

using namespace std;

#define fori(i, n) for(int i = 0; i < n; i ++)
#define edilya adilichka
#define all(v) v.begin(), v.end()
#define int long long

vector<vector<pair<int, int>>> gr;
vector<vector<int>> dp;
int n, k;
int inf = 1e15;

void dfs(int v, int p = -1) {
    dp[v][0] = 0;
    for (pair<int, int> u: gr[v]) {
        if (u.first == p)continue;
        for (int i = 1; i < k; i++) {
            dp[v][i] = min(dp[v][i], dp[u.first][i - 1] + u.second);
        }
        dfs(u.first, v);
    }
}


signed main() {
    cin.tie(nullptr), cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
//    freopen("input.txt", "r", stdin);
    cin >> n >> k;
    ++k;
    dp.resize(n, vector<int>(k));
    fori(i, n) {
        fori(j, k)dp[i][j] = inf;
    }
    gr.resize(n, vector<pair<int, int>>());
    fori(v, n - 1) {
        int u, w;
        cin >> u >> w;
        --u;
        gr[u].emplace_back(make_pair(v, w));
        gr[v].emplace_back(make_pair(u, w));
    }
    dfs(0);
    pair<int, int> ans = {0, 0};
    fori(i, n) {
        fori(j, k) {
            if (dp[i][j] != inf && j > ans.first)ans = {j, dp[i][j]};
            if (j == ans.first) {
                ans.second = min(ans.second, dp[i][j]);
            }
        }
    }
    cout << ans.first - 1 << " " << ans.second;

}